/* timer.c   timer package

   Prabhas Chongstitvatana       20 Aug 98
*/

#include "interp.h"

#define	PRIVATE		static

struct { long time;
	 pdesc id;      /* owner of this timer */
	 int info; 	/* info for undo when timeout */
	 tmp next;
} timer[maxtimer];

tmp freetm, tmlist;
long vclock;

PRIVATE void deletetm()
{
  tmp a;
  a = tmlist;
  tmlist = timer[tmlist].next;
  timer[a].next = freetm;
  freetm = a;
}

PRIVATE tmp getatimer()
{
  tmp a;
  a = freetm;
  if( a == nil ) error( "no more timer");
  freetm = timer[freetm].next;
  timer[a].next = nil;
  return a;
}

PRIVATE inserttm( tmp t )
{
  tmp a, b;
  a = tmlist;
  b = a;
  while( a != nil && timer[a].time < timer[t].time ) {
    b = a;
    a = timer[a].next;
  }
  if( a == b ) {
    timer[t].next = tmlist;
    tmlist = t;
  } else {
    timer[b].next = t;
    timer[t].next = a;
  }
}

void inittimer()
{
  int i;
  vclock = 0;
  freetm = 1;
  tmlist = nil;
  for( i=0; i<maxtimer-2; i++ )
    timer[i].next = i+1;
  timer[maxtimer-1].next = nil;
}

void deletetmid( pdesc p ) /* delete timer of p */
{
  tmp a, b;
  a = tmlist;
  b = a;
  while( a != nil && timer[a].id != p ) {
    b = a;
    a = timer[a].next;
  }
  if( a == nil ) error("attemp to delete non exist timer");
  if( a == b ) 		/* the only timer */
    tmlist = nil;
  else
    timer[b].next = timer[a].next;
  timer[a].next = freetm;
  freetm = a;
}

PRIVATE void tmawake( pdesc p, int info )
{
  switch( pcb[p].state ) {
  case TMWAIT :
    removesemid( info, p );
    pcb[p].ip += 3;	/* jump to do body */
    break;
  case TMSEND :
    undombox( info, p );
    pcb[p].ip += 3;
    break;
  case TMRECEIVE :
    undoawait( info, p );
    pcb[p].ip += 3;
    break;
  case DELAY :  break;
  }
  wakeup(p);
}

void dotimer()
{
  pdesc p;
  int info;
  while( tmlist != nil && timer[tmlist].time <= vclock ) {
    p = timer[tmlist].id;
    info = timer[tmlist].info;
    deletetm();
    tmawake(p, info);
  }
}

void starttimer( int dt, int info )
{
  tmp a;
  a = getatimer();
  timer[a].time = vclock + dt;
  timer[a].id = activep;
  timer[a].info = info;
  inserttm(a);
}

xDelay()
{
  ip++;
  starttimer(pop(),0);
  blockp(DELAY);
}

xGettime()	/* 16 bit system */
{
  int ads;
  ip++;
  ads = pop();
  M[ads] = (int)( vclock >> 16 & 0xffff);
  M[ads+1] = (int) ( vclock & 0xffff);
}

#ifdef DEBUG
void showtm()
{
  tmp i;
  int cnt;
  cnt = 0;
  i = tmlist;
  while( i != nil && cnt++ < 10 ) {
    printf("id %d time %ld info %d\n",
      timer[i].id, timer[i].time, timer[i].info );
    i = timer[i].next;
  }
}

void showfreetm()
{
  tmp i;
  int cnt;
  cnt = 0;
  i = freetm;
  while ( i != nil && cnt++ < 10 ) {
    printf("free %d\n",i);
    i = timer[i].next;
  }
}
#endif
