/* icode.c
	P. Chongstitvatana
							27 Aug 97
   add tmSend, tmSignal, tmWait, delay, gettime		21 Aug 98
*/

#include "compile.h"

#define		PRIVATE		static

uchar CS[MAXCS];
int CP = 1;

extern sym_entry symtab[];
extern FILE *FO;

typedef struct {
  char str[10];
  char opr;
  char brk;
} ic_entry;

PRIVATE ic_entry icProp[] = {
  "lit", 	2, 	0,
  "lval", 	2, 	0,
  "lvalg", 	2, 	0,
  "rval",  	2, 	0,
  "rvalg", 	2, 	0,
  "fetch", 	0, 	0,
  "set",  	0,	1,
  "index", 	0, 	0,
  "jmp", 	2,	1,
  "jz", 	2,	1,
  "call", 	2,	1,
  "func", 	4,	1,
  "proc", 	6,	1,
  "ret0", 	0,	1,
  "ret1", 	0,	1,
  "stop", 	0,	1,
  "add", 	0,	0,
  "sub", 	0,	0,
  "mul", 	0,	0,
  "div", 	0,	0,
  "minus", 	0,	0,
  "not", 	0,	0,
  "and", 	0,	0,
  "or",  	0,	0,
  "lt",  	0,	1,
  "le",  	0,	1,
  "eq",  	0,	1,
  "ne",  	0,	1,
  "ge",  	0,	1,
  "gt",  	0,	1,
  "print", 	0,	1,
  "printch", 	0,	1,
  "send", 	0,	1,
  "receive", 	0,	1,
  "wait",   	2,	1,
  "signal", 	2,	1,
  "nop", 	0,	0,
  "tmsend", 	0, 	1,
  "tmreceive", 	0, 	1,
  "tmwait", 	2, 	1,
  "delay",  	0, 	0,
  "gettime",	0, 	1
};

PRIVATE int ip;

PRIVATE showOpr( int n )
{
  while( n > 0 ) {
    fprintf(FO,"%d ",CS[ip]*256 + CS[ip+1]);
	 ip += 2;
    n -= 2;
  }
}

PRIVATE int getInt(int i)
{
  return CS[i]*256 + CS[i+1];
}

showCode()
{
  int c;
  ip = 1;
  fprintf(FO,"\n%5d: ",ip);
  while( ip < CP ) {
    c = CS[ip++];
    fprintf(FO,"%s ",icProp[c].str);
	 showOpr(icProp[c].opr);
    if( icProp[c].brk )
      fprintf(FO,"\n%5d: ",ip);
  }
}

out( uchar code )
{
  CS[CP] = code;
  CP++;
}

out1( int c1 )
{
  CS[CP] = c1 / 256;
  CS[CP+1] = c1 % 256;
  CP += 2;
}

out2( uchar c1, int c2 )
{
  CS[CP] = c1;
  CS[CP+1] = c2 / 256;
  CS[CP+2] = c2 % 256;
  CP += 3;
}

out3( uchar c1, int c2, int c3 )
{
  CS[CP] = c1;
  CS[CP+1] = c2 / 256;
  CS[CP+2] = c2 % 256;
  CS[CP+3] = c3 / 256;
  CS[CP+4] = c3 % 256;
  CP += 5;
}

patch( int ads, int v )
{
  CS[ads] = v / 256;
  CS[ads+1] = v % 256;
}

dumpCode()
{
  int i;
  for( i=1; i<CP; i++ )
    putc(CS[i],FO);
}

reName()
{
  int i, n = 0;
  for( i=1; i<CP; i += icProp[CS[i]].opr + 1 ) {
	 switch( CS[i] ) {
    case icFunc : n = getInt(i+1) + getInt(i+3); break;
    case icProc : n = getInt(i+3) + getInt(i+5); break;
    case icLval :
    case icRval : patch(i+1, n - getInt(i+1) ); break;
    case icCall : patch(i+1, symtab[getInt(i+1)].ref); break;
    }
  }
}
